
library ieee ;
use ieee.std_logic_1164.all ;
use work.vlabifhw_pack.all;

entity Autogen_Debug_Entity is
port (
		cpu_address         : out std_logic_vector ( 31 downto 0 ) ;
		cpu_data_in         : out std_logic_vector ( 31 downto 0 ) ;
		cpu_data_out        : in std_logic_vector ( 31 downto 0 ) ;
		cpu_copy_loc        : out std_logic_vector ( 10 downto 0 ) ;
		cpu_size            : out std_logic_vector ( 10 downto 0 ) ;
		cpu_ben             : out std_logic_vector ( 3 downto 0 ) ;
		cpu_write           : out std_logic ;
		cpu_read            : out std_logic ;
		cpu_open            : out std_logic ;
		cpu_close           : out std_logic ;
		cpu_read_only       : out std_logic ;
		cpu_ack             : in std_logic ;
		mst_cntl_rd_req     : in std_logic ;
		mst_cntl_wr_req     : in std_logic ;
		mst_cntl_bus_lock   : in std_logic ;
		mst_cntl_burst      : in std_logic ;
		mst_ip2bus_addr     : in std_logic_vector ( 31 downto 0 ) ;
		mst_ip2bus_be       : in std_logic_vector ( 15 downto 0 ) ;
		mst_xfer_length     : in std_logic_vector ( 11 downto 0 ) ;
		mst_go              : in std_logic ;
		mst_cmd_sm_set_done : out std_logic ;
		mst_cmd_sm_set_error: out std_logic ;
		mst_cmd_sm_set_timeout: out std_logic ;
		mst_cmd_sm_busy     : out std_logic ;
		mst_cmd_sm_clr_go   : out std_logic ;
		output_next         : out std_logic ;
		input_next          : out std_logic ;
		data_output         : in std_logic_vector ( 31 downto 0 ) ;
		data_input          : out std_logic_vector ( 31 downto 0 ) ;
		match_mask          : out std_logic_vector ( 7 downto 0 ) ;
		reset               : out std_logic ;
		dbg_cpu_side_address: in std_logic_vector ( 10 downto 0 ) ;
		dbg_bus_side_address: in std_logic_vector ( 10 downto 0 ) ;
		dbg_cpu_side_data_in: in std_logic_vector ( 31 downto 0 ) ;
		dbg_cpu_side_data_out: in std_logic_vector ( 31 downto 0 ) ;
		dbg_bus_side_data_in: in std_logic_vector ( 31 downto 0 ) ;
		dbg_bus_side_data_out: in std_logic_vector ( 31 downto 0 ) ;
		dbg_cpu_side_write  : in std_logic ;
		dbg_bus_side_write  : in std_logic ;
		dbg_bus_side_cen    : in std_logic ;
		dbg_match           : in std_logic ;
		dbg_match_in_read_only_area: in std_logic ;
		dbg_miss            : in std_logic ;
		dbg_hit             : in std_logic ;
		dbg_read_only_update_pos: in std_logic_vector ( 3 downto 0 ) ;
		dbg_update_burst_boundary: in std_logic ;
		dbg_match_address   : in std_logic_vector ( 31 downto 0 ) ;
		dbg_code            : in std_logic_vector ( 7 downto 0 ) ;
		dbg_sp_cpu_valid    : in std_logic ;
		dbg_slow_ack        : in std_logic ;
		dbg_row_activation  : in std_logic_vector ( 15 downto 0 ) ;
		dbg_match_ref       : in std_logic_vector ( 3 downto 0 ) ;
		cache_active        : out std_logic ;
		cpu_cache_set_perm  : out std_logic ;
		cpu_cache_invalidate: out std_logic ;
		dbg_tag_address     : in std_logic_vector ( 9 downto 0 ) ;
		dbg_permutation_in  : in std_logic_vector ( 9 downto 0 ) ;
		dbg_cache_hit       : in std_logic ;
		dbg_tag_in_16       : in std_logic_vector ( 15 downto 0 ) ;
		dbg_tag_out_16      : in std_logic_vector ( 15 downto 0 ) ;
		dbg_permutation_out : in std_logic_vector ( 15 downto 0 ) ;
		dbg_cache_read      : in std_logic ;
		dbg_cache_write     : in std_logic ;
		dbg_enable_permutation: in std_logic ;

		dc_control          : in DC_Control_Wires;
		dc_out              : out std_logic;
		dc_in               : in std_logic ) ;
end entity Autogen_Debug_Entity ;

architecture dc1 of Autogen_Debug_Entity is

signal Autogen_Debug_Entity_section_0 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_1 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_2 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_3 
                : std_logic_vector ( 10 downto 0 ) ;

signal Autogen_Debug_Entity_section_4 
                : std_logic_vector ( 10 downto 0 ) ;

signal Autogen_Debug_Entity_section_5 
                : std_logic_vector ( 3 downto 0 ) ;

signal Autogen_Debug_Entity_section_6 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_7 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_8 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_9 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_10 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_11 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_12 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_13 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_14 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_15 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_16 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_17 
                : std_logic_vector ( 15 downto 0 ) ;

signal Autogen_Debug_Entity_section_18 
                : std_logic_vector ( 11 downto 0 ) ;

signal Autogen_Debug_Entity_section_19 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_20 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_21 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_22 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_23 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_24 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_25 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_26 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_27 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_28 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_29 
                : std_logic_vector ( 7 downto 0 ) ;

signal Autogen_Debug_Entity_section_30 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_31 
                : std_logic_vector ( 10 downto 0 ) ;

signal Autogen_Debug_Entity_section_32 
                : std_logic_vector ( 10 downto 0 ) ;

signal Autogen_Debug_Entity_section_33 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_34 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_35 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_36 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_37 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_38 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_39 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_40 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_41 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_42 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_43 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_44 
                : std_logic_vector ( 3 downto 0 ) ;

signal Autogen_Debug_Entity_section_45 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_46 
                : std_logic_vector ( 31 downto 0 ) ;

signal Autogen_Debug_Entity_section_47 
                : std_logic_vector ( 7 downto 0 ) ;

signal Autogen_Debug_Entity_section_48 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_49 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_50 
                : std_logic_vector ( 15 downto 0 ) ;

signal Autogen_Debug_Entity_section_51 
                : std_logic_vector ( 3 downto 0 ) ;

signal Autogen_Debug_Entity_section_52 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_53 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_54 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_55 
                : std_logic_vector ( 9 downto 0 ) ;

signal Autogen_Debug_Entity_section_56 
                : std_logic_vector ( 9 downto 0 ) ;

signal Autogen_Debug_Entity_section_57 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_58 
                : std_logic_vector ( 15 downto 0 ) ;

signal Autogen_Debug_Entity_section_59 
                : std_logic_vector ( 15 downto 0 ) ;

signal Autogen_Debug_Entity_section_60 
                : std_logic_vector ( 15 downto 0 ) ;

signal Autogen_Debug_Entity_section_61 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_62 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_63 
                : std_logic_vector ( 0 downto 0 ) ;

signal Autogen_Debug_Entity_section_64 
                : std_logic_vector ( 11 downto 0 ) ;

signal Autogen_Debug_Entity_section_65 : 
            std_logic_vector ( 0 downto 0 ) ;

begin

Autogen_Debug_Entity_0 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_address <= Autogen_Debug_Entity_section_0  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_0 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_0 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_0 ( 31 ) <=
                        Autogen_Debug_Entity_section_1 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_0 ;

Autogen_Debug_Entity_1 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_data_in <= Autogen_Debug_Entity_section_1  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_1 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_1 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_1 ( 31 ) <=
                        Autogen_Debug_Entity_section_2 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_1 ;

Autogen_Debug_Entity_2 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_2  <= cpu_data_out ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_2 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_2 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_2 ( 31 ) <=
                        Autogen_Debug_Entity_section_3 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_2 ;

Autogen_Debug_Entity_3 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_copy_loc <= Autogen_Debug_Entity_section_3  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_3 ( 10 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_3 ( 10 downto 1 ) ;
                
            Autogen_Debug_Entity_section_3 ( 10 ) <=
                        Autogen_Debug_Entity_section_4 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_3 ;

Autogen_Debug_Entity_4 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_size <= Autogen_Debug_Entity_section_4  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_4 ( 10 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_4 ( 10 downto 1 ) ;
                
            Autogen_Debug_Entity_section_4 ( 10 ) <=
                        Autogen_Debug_Entity_section_5 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_4 ;

Autogen_Debug_Entity_5 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_ben <= Autogen_Debug_Entity_section_5  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_5 ( 3 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_5 ( 3 downto 1 ) ;
                
            Autogen_Debug_Entity_section_5 ( 3 ) <=
                        Autogen_Debug_Entity_section_6 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_5 ;

Autogen_Debug_Entity_6 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_write <= Autogen_Debug_Entity_section_6 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_6 ( 0 ) <=
                        Autogen_Debug_Entity_section_7 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_6 ;

Autogen_Debug_Entity_7 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_read <= Autogen_Debug_Entity_section_7 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_7 ( 0 ) <=
                        Autogen_Debug_Entity_section_8 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_7 ;

Autogen_Debug_Entity_8 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_open <= Autogen_Debug_Entity_section_8 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_8 ( 0 ) <=
                        Autogen_Debug_Entity_section_9 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_8 ;

Autogen_Debug_Entity_9 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_close <= Autogen_Debug_Entity_section_9 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_9 ( 0 ) <=
                        Autogen_Debug_Entity_section_10 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_9 ;

Autogen_Debug_Entity_10 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_read_only <= Autogen_Debug_Entity_section_10 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_10 ( 0 ) <=
                        Autogen_Debug_Entity_section_11 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_10 ;

Autogen_Debug_Entity_11 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_11 ( 0 ) <= cpu_ack ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_11 ( 0 ) <=
                        Autogen_Debug_Entity_section_12 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_11 ;

Autogen_Debug_Entity_12 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_12 ( 0 ) <= mst_cntl_rd_req ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_12 ( 0 ) <=
                        Autogen_Debug_Entity_section_13 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_12 ;

Autogen_Debug_Entity_13 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_13 ( 0 ) <= mst_cntl_wr_req ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_13 ( 0 ) <=
                        Autogen_Debug_Entity_section_14 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_13 ;

Autogen_Debug_Entity_14 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_14 ( 0 ) <= mst_cntl_bus_lock ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_14 ( 0 ) <=
                        Autogen_Debug_Entity_section_15 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_14 ;

Autogen_Debug_Entity_15 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_15 ( 0 ) <= mst_cntl_burst ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_15 ( 0 ) <=
                        Autogen_Debug_Entity_section_16 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_15 ;

Autogen_Debug_Entity_16 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_16  <= mst_ip2bus_addr ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_16 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_16 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_16 ( 31 ) <=
                        Autogen_Debug_Entity_section_17 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_16 ;

Autogen_Debug_Entity_17 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_17  <= mst_ip2bus_be ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_17 ( 15 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_17 ( 15 downto 1 ) ;
                
            Autogen_Debug_Entity_section_17 ( 15 ) <=
                        Autogen_Debug_Entity_section_18 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_17 ;

Autogen_Debug_Entity_18 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_18  <= mst_xfer_length ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_18 ( 11 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_18 ( 11 downto 1 ) ;
                
            Autogen_Debug_Entity_section_18 ( 11 ) <=
                        Autogen_Debug_Entity_section_19 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_18 ;

Autogen_Debug_Entity_19 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_19 ( 0 ) <= mst_go ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_19 ( 0 ) <=
                        Autogen_Debug_Entity_section_20 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_19 ;

Autogen_Debug_Entity_20 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            mst_cmd_sm_set_done <= Autogen_Debug_Entity_section_20 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_20 ( 0 ) <=
                        Autogen_Debug_Entity_section_21 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_20 ;

Autogen_Debug_Entity_21 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            mst_cmd_sm_set_error <= Autogen_Debug_Entity_section_21 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_21 ( 0 ) <=
                        Autogen_Debug_Entity_section_22 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_21 ;

Autogen_Debug_Entity_22 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            mst_cmd_sm_set_timeout <= Autogen_Debug_Entity_section_22 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_22 ( 0 ) <=
                        Autogen_Debug_Entity_section_23 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_22 ;

Autogen_Debug_Entity_23 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            mst_cmd_sm_busy <= Autogen_Debug_Entity_section_23 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_23 ( 0 ) <=
                        Autogen_Debug_Entity_section_24 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_23 ;

Autogen_Debug_Entity_24 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            mst_cmd_sm_clr_go <= Autogen_Debug_Entity_section_24 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_24 ( 0 ) <=
                        Autogen_Debug_Entity_section_25 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_24 ;

Autogen_Debug_Entity_25 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            output_next <= Autogen_Debug_Entity_section_25 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_25 ( 0 ) <=
                        Autogen_Debug_Entity_section_26 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_25 ;

Autogen_Debug_Entity_26 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            input_next <= Autogen_Debug_Entity_section_26 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_26 ( 0 ) <=
                        Autogen_Debug_Entity_section_27 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_26 ;

Autogen_Debug_Entity_27 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_27  <= data_output ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_27 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_27 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_27 ( 31 ) <=
                        Autogen_Debug_Entity_section_28 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_27 ;

Autogen_Debug_Entity_28 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            data_input <= Autogen_Debug_Entity_section_28  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_28 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_28 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_28 ( 31 ) <=
                        Autogen_Debug_Entity_section_29 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_28 ;

Autogen_Debug_Entity_29 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            match_mask <= Autogen_Debug_Entity_section_29  ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_29 ( 7 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_29 ( 7 downto 1 ) ;
                
            Autogen_Debug_Entity_section_29 ( 7 ) <=
                        Autogen_Debug_Entity_section_30 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_29 ;

Autogen_Debug_Entity_30 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            reset <= Autogen_Debug_Entity_section_30 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_30 ( 0 ) <=
                        Autogen_Debug_Entity_section_31 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_30 ;

Autogen_Debug_Entity_31 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_31  <= dbg_cpu_side_address ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_31 ( 10 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_31 ( 10 downto 1 ) ;
                
            Autogen_Debug_Entity_section_31 ( 10 ) <=
                        Autogen_Debug_Entity_section_32 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_31 ;

Autogen_Debug_Entity_32 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_32  <= dbg_bus_side_address ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_32 ( 10 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_32 ( 10 downto 1 ) ;
                
            Autogen_Debug_Entity_section_32 ( 10 ) <=
                        Autogen_Debug_Entity_section_33 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_32 ;

Autogen_Debug_Entity_33 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_33  <= dbg_cpu_side_data_in ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_33 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_33 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_33 ( 31 ) <=
                        Autogen_Debug_Entity_section_34 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_33 ;

Autogen_Debug_Entity_34 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_34  <= dbg_cpu_side_data_out ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_34 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_34 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_34 ( 31 ) <=
                        Autogen_Debug_Entity_section_35 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_34 ;

Autogen_Debug_Entity_35 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_35  <= dbg_bus_side_data_in ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_35 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_35 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_35 ( 31 ) <=
                        Autogen_Debug_Entity_section_36 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_35 ;

Autogen_Debug_Entity_36 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_36  <= dbg_bus_side_data_out ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_36 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_36 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_36 ( 31 ) <=
                        Autogen_Debug_Entity_section_37 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_36 ;

Autogen_Debug_Entity_37 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_37 ( 0 ) <= dbg_cpu_side_write ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_37 ( 0 ) <=
                        Autogen_Debug_Entity_section_38 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_37 ;

Autogen_Debug_Entity_38 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_38 ( 0 ) <= dbg_bus_side_write ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_38 ( 0 ) <=
                        Autogen_Debug_Entity_section_39 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_38 ;

Autogen_Debug_Entity_39 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_39 ( 0 ) <= dbg_bus_side_cen ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_39 ( 0 ) <=
                        Autogen_Debug_Entity_section_40 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_39 ;

Autogen_Debug_Entity_40 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_40 ( 0 ) <= dbg_match ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_40 ( 0 ) <=
                        Autogen_Debug_Entity_section_41 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_40 ;

Autogen_Debug_Entity_41 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_41 ( 0 ) <= dbg_match_in_read_only_area ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_41 ( 0 ) <=
                        Autogen_Debug_Entity_section_42 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_41 ;

Autogen_Debug_Entity_42 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_42 ( 0 ) <= dbg_miss ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_42 ( 0 ) <=
                        Autogen_Debug_Entity_section_43 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_42 ;

Autogen_Debug_Entity_43 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_43 ( 0 ) <= dbg_hit ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_43 ( 0 ) <=
                        Autogen_Debug_Entity_section_44 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_43 ;

Autogen_Debug_Entity_44 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_44  <= dbg_read_only_update_pos ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_44 ( 3 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_44 ( 3 downto 1 ) ;
                
            Autogen_Debug_Entity_section_44 ( 3 ) <=
                        Autogen_Debug_Entity_section_45 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_44 ;

Autogen_Debug_Entity_45 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_45 ( 0 ) <= dbg_update_burst_boundary ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_45 ( 0 ) <=
                        Autogen_Debug_Entity_section_46 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_45 ;

Autogen_Debug_Entity_46 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_46  <= dbg_match_address ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_46 ( 31 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_46 ( 31 downto 1 ) ;
                
            Autogen_Debug_Entity_section_46 ( 31 ) <=
                        Autogen_Debug_Entity_section_47 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_46 ;

Autogen_Debug_Entity_47 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_47  <= dbg_code ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_47 ( 7 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_47 ( 7 downto 1 ) ;
                
            Autogen_Debug_Entity_section_47 ( 7 ) <=
                        Autogen_Debug_Entity_section_48 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_47 ;

Autogen_Debug_Entity_48 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_48 ( 0 ) <= dbg_sp_cpu_valid ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_48 ( 0 ) <=
                        Autogen_Debug_Entity_section_49 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_48 ;

Autogen_Debug_Entity_49 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_49 ( 0 ) <= dbg_slow_ack ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_49 ( 0 ) <=
                        Autogen_Debug_Entity_section_50 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_49 ;

Autogen_Debug_Entity_50 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_50  <= dbg_row_activation ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_50 ( 15 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_50 ( 15 downto 1 ) ;
                
            Autogen_Debug_Entity_section_50 ( 15 ) <=
                        Autogen_Debug_Entity_section_51 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_50 ;

Autogen_Debug_Entity_51 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_51  <= dbg_match_ref ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_51 ( 3 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_51 ( 3 downto 1 ) ;
                
            Autogen_Debug_Entity_section_51 ( 3 ) <=
                        Autogen_Debug_Entity_section_52 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_51 ;

Autogen_Debug_Entity_52 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cache_active <= Autogen_Debug_Entity_section_52 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_52 ( 0 ) <=
                        Autogen_Debug_Entity_section_53 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_52 ;

Autogen_Debug_Entity_53 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_cache_set_perm <= Autogen_Debug_Entity_section_53 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_53 ( 0 ) <=
                        Autogen_Debug_Entity_section_54 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_53 ;

Autogen_Debug_Entity_54 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_ready = '1' )
        then
            cpu_cache_invalidate <= Autogen_Debug_Entity_section_54 ( 0 ) ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_54 ( 0 ) <=
                        Autogen_Debug_Entity_section_55 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_54 ;

Autogen_Debug_Entity_55 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_55  <= dbg_tag_address ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_55 ( 9 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_55 ( 9 downto 1 ) ;
                
            Autogen_Debug_Entity_section_55 ( 9 ) <=
                        Autogen_Debug_Entity_section_56 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_55 ;

Autogen_Debug_Entity_56 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_56  <= dbg_permutation_in ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_56 ( 9 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_56 ( 9 downto 1 ) ;
                
            Autogen_Debug_Entity_section_56 ( 9 ) <=
                        Autogen_Debug_Entity_section_57 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_56 ;

Autogen_Debug_Entity_57 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_57 ( 0 ) <= dbg_cache_hit ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_57 ( 0 ) <=
                        Autogen_Debug_Entity_section_58 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_57 ;

Autogen_Debug_Entity_58 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_58  <= dbg_tag_in_16 ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_58 ( 15 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_58 ( 15 downto 1 ) ;
                
            Autogen_Debug_Entity_section_58 ( 15 ) <=
                        Autogen_Debug_Entity_section_59 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_58 ;

Autogen_Debug_Entity_59 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_59  <= dbg_tag_out_16 ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_59 ( 15 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_59 ( 15 downto 1 ) ;
                
            Autogen_Debug_Entity_section_59 ( 15 ) <=
                        Autogen_Debug_Entity_section_60 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_59 ;

Autogen_Debug_Entity_60 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_60  <= dbg_permutation_out ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_60 ( 15 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_60 ( 15 downto 1 ) ;
                
            Autogen_Debug_Entity_section_60 ( 15 ) <=
                        Autogen_Debug_Entity_section_61 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_60 ;

Autogen_Debug_Entity_61 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_61 ( 0 ) <= dbg_cache_read ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_61 ( 0 ) <=
                        Autogen_Debug_Entity_section_62 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_61 ;

Autogen_Debug_Entity_62 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_62 ( 0 ) <= dbg_cache_write ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_62 ( 0 ) <=
                        Autogen_Debug_Entity_section_63 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_62 ;

Autogen_Debug_Entity_63 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_63 ( 0 ) <= dbg_enable_permutation ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_63 ( 0 ) <=
                        Autogen_Debug_Entity_section_64 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_63 ;

Autogen_Debug_Entity_64 : process ( dc_control.dc_clock ) is
begin
    if (( dc_control.dc_clock = '1' ) and dc_control.dc_clock'event )
    then
        if ( dc_control.dc_capture = '1' )
        then
            Autogen_Debug_Entity_section_64 <= "101000000001" ;
        end if;
        if ( dc_control.dc_shift = '1' )
        then
            
            Autogen_Debug_Entity_section_64 ( 11 - 1 downto 0 ) <=
                        Autogen_Debug_Entity_section_64 ( 11 downto 1 ) ;
                
            Autogen_Debug_Entity_section_64 ( 11 ) <=
                        Autogen_Debug_Entity_section_65 ( 0 ) ;
        end if ;
    end if ;
end process Autogen_Debug_Entity_64 ;

Autogen_Debug_Entity_section_65 ( 0 ) <= dc_in ;
dc_out <= Autogen_Debug_Entity_section_0 ( 0 ) ;

end architecture dc1 ;


