import vlab
from twisted.internet import reactor, defer
from vlab import terminal

class DT1(terminal.DumbTerminal):
    def write(self, data):
        if ( "\x04" in data ):
            print "\r"
            print "\rExit"
            reactor.stop()
        else: 
            terminal.DumbTerminal.write(self, data)
            
    def dataReceived(self, data):
        terminal.DumbTerminal.dataReceived(self, data)
        # log here


@defer.inlineCallbacks
def Run():
    print 'Loading bit file'
    bits = file("hwmethods-dist/hw/toplevel.bit", "rb").read()

    print 'Connecting to the board'
    auth = vlab.loadAuthorisation("/home/jack/jack-vl2.key")
    vlf = vlab.VlabClientFactory(auth)
    reactor.connectTCP(auth.relay_server_name, 22, vlf)
    vl = yield vlf.getChannel()
    yield vl.connect("ml505")

    print 'Hold reset'
    yield vl.setRelay(1, 1)
    print 'Sending bit file'
    bid = yield vl.sendBitfile(bits)
    print 'Bid is', bid
    yield vl.programFPGA(0, bid)
    print 'Release reset'
    yield vl.setUART(0, 38400)
    yield vl.setRelay(1, 0)

    print 'Go'
    print '------------'
    uart = DT1()
    terminal.setTransport(uart)
    yield vl.openUART(0, uart)

if ( __name__ == "__main__" ):
    reactor.addSystemEventTrigger('after', 'startup', Run)
    reactor.run()

